Download it now!
Bug 134436 - Crash specific undo/redo dance
Summary: Crash specific undo/redo dance
Status: VERIFIED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Writer (show other bugs)
Version:
(earliest affected)
7.0.0.0.alpha0+
Hardware: All All
: medium critical
Assignee: Michael Stahl (CIB)
URL:
Whiteboard: target:7.1.0 target:7.0.1 target:6.4.7
Keywords: bibisected, bisected, regression
Depends on:
Blocks: Crash redline-regressions
  Show dependency treegraph
 
Reported: 2020-07-01 12:55 UTC by Telesto
Modified: 2020-11-19 11:08 UTC (History)
4 users (show)

See Also:
Crash report or crash signature:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Telesto 2020-07-01 12:55:54 UTC
Description:
Crash specific undo/redo dance

Steps to Reproduce:
1. Open attachment 155421 [details] (bug 132156 bug 131684)
CTRL+A 3x
CTRL+X
CTRL+V
CTRL+Z
CTRL+Z
CTRL+V
CTRL+Z
CTRL+Y
CTRL+Z
CTRL+V
CTRL+Z


Actual Results:
Crash

Expected Results:
No crash


Reproducible: Always


User Profile Reset: No



Additional Info:
Version: 7.1.0.0.alpha0+ (x64)
Build ID: 4c14c88cc681abab787a461a1bea502a777f37e6
CPU threads: 4; OS: Windows 6.3 Build 9600; UI render: Skia/Raster; VCL: win
Locale: nl-NL (nl_NL); UI: en-US
Calc: CL

no repro with
Versie: 4.4.7.2 
Build ID: f3153a8b245191196a4b6b9abd1d0da16eead600
Locale: nl_NL
Comment 1 Buovjaga 2020-07-08 20:17:38 UTC
Didn't yet bibisect the "no crash -> crash" state, but the change in what step in the dance triggers the crash happened with https://git.libreoffice.org/core/+/6c7245e789f973cf6dad03f7008ab3f9d12d350c%5E!/

Other blamed reports:
https://bugs.documentfoundation.org/buglist.cgi?keywords=regression%2C%20&keywords_type=allwords&list_id=1166011&longdesc=6c7245e789f973cf6dad03f7008ab3f9d12d350c&longdesc_type=allwordssubstr&query_format=advanced

Bibisected with Win 6.5 repo. Linux repo had crashing upon opening.
Comment 2 Buovjaga 2020-07-14 17:22:42 UTC
The crashing with this sequence:
CTRL+A 3x
CTRL+X
CTRL+V
CTRL+Z
CTRL+Z
CTRL+V
CTRL+Z

started with

https://git.libreoffice.org/core/commit/723728cd358693b8f4bc9d913541aa4479f2bd48
sw_redlinehide_2: SwUndoDelete

Bibisected with win32-6.2

Adding Cc: to Michael Stahl

Tested the full sequence still crashes with latest Win build
Comment 3 Telesto 2020-07-14 18:09:41 UTC
Should I develop a feeling guilty complex? Michael Stahl being the victim of my fiddling around with undo/redo/paste?
Comment 4 Thorsten Behrens (CIB) 2020-07-23 11:19:03 UTC
Hmm. There's an infinite number of those problems still lurking in Writer (which has used an early 90ties not mem safe programming paradigm) - I'd advocate not over-using severity critical (as the bugdoc itself was already crashing for the original reporter, in bug 128497). The current theory is, that internal writer state is corrupted right after loading, and the undo/redo dance is just the unhappy winner of hitting the trapdoor first.
Comment 5 Buovjaga 2020-07-23 11:28:41 UTC
(In reply to Thorsten Behrens (CIB) from comment #4)
> Hmm. There's an infinite number of those problems still lurking in Writer
> (which has used an early 90ties not mem safe programming paradigm) - I'd
> advocate not over-using severity critical (as the bugdoc itself was already
> crashing for the original reporter, in bug 128497).

Severity: critical is semantically correct. Note that priority is merely medium.
Comment 6 Commit Notification 2020-07-31 09:49:12 UTC
Michael Stahl committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/core/commit/22a77cb83a3769a8b43d80565282988a74214866

tdf#134436 sw: fix SwUndoDelete::RedoImpl() with section at end...

It will be available in 7.1.0.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 7 Michael Stahl (CIB) 2020-07-31 09:56:53 UTC
this wasn't really a regression, but that wasn't obvious from the start...

fixed on master.
Comment 8 Commit Notification 2020-08-01 22:05:36 UTC
Michael Stahl committed a patch related to this issue.
It has been pushed to "libreoffice-7-0":

https://git.libreoffice.org/core/commit/50af5ecd1484457cccb8a62b920bf78cbe49d253

tdf#134436 sw: fix SwUndoDelete::RedoImpl() with section at end...

It will be available in 7.0.1.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 9 Commit Notification 2020-08-01 22:07:04 UTC
Michael Stahl committed a patch related to this issue.
It has been pushed to "libreoffice-6-4":

https://git.libreoffice.org/core/commit/a45400449536d75b4858821d88197fffefe66631

tdf#134436 sw: fix SwUndoDelete::RedoImpl() with section at end...

It will be available in 6.4.7.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 10 Xisco Faulí 2020-08-10 10:31:15 UTC
Verified in

Version: 7.1.0.0.alpha0+
Build ID: 6ad2f463784a24c566477cdd60ae729651bb8564
CPU threads: 4; OS: Linux 4.19; UI render: default; VCL: gtk3
Locale: en-US (en_US.UTF-8); UI: en-US
Calc: threaded

@Michael Stahl, thanks for fixing this issue!!